
//   by naruman, rodocop, ...
//   TEST little modif. 2017-05-06 siria (allow a default override UA, if site is not stored)
//   ATTENTION:   FF38 and KM76 are hardcoded below!  Change below if necessary

const Cc = Components.classes;
const Ci = Components.interfaces;

Components.utils.import('resource://gre/modules/XPCOMUtils.jsm');
Components.utils.import('resource://gre/modules/Services.jsm');

XPCOMUtils.defineLazyServiceGetter(this, 'UsAgent', '@mozilla.org/network/protocol;1?name=http', 'nsIHttpProtocolHandler');

const uSOverride		=	'general.useragent.override';
const uSString			=	"kmeleon.privacy.useragent";

function nsKmeleonMain() {
	this.wrappedJSObject = this;
	this.prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch(null);
}
nsKmeleonMain.prototype = {
classID:	Components.ID('{FD1A56FA-0A19-424f-8C9D-FBBFF7CFEB07}'),


userAgent: function(aSubject) {
	
	var prefs = Cc['@mozilla.org/preferences-service;1'].getService(Ci.nsIPrefService).getBranch(null),
	nsIChannel = aSubject.QueryInterface(Ci.nsIChannel), 
	nsIHttpChannel = aSubject.QueryInterface(Ci.nsIHttpChannel),
//	NoUserAgent=prefs.getBoolPref(uSString+'.nouseragent'),
	Count=prefs.getIntPref(uSString+'.Count'),
	UrlHost=nsIChannel.URI.host;

//		if(NoUserAgent){
//		prefs.setCharPref(uSOverride, "");
//		return;
//		}
		
		if(Count != null){

			var overrideString = prefs.getCharPref('general.useragent.override');

			overrideString ? 0 : overrideString = 'Mozilla/5.0 (' + UsAgent.oscpu + '; ' + UsAgent.misc + ') Gecko/20100101 Firefox/38.0 K-Meleon/76.0'  ;

			for (var i = 0; i < Count; i++) {
				var j=i+1;
				var uaSites=prefs.getCharPref(uSString+j+'.sites');
				if(uaSites.indexOf(UrlHost)>-1){
					overrideString=prefs.getCharPref(uSString+j+'.string');
				}
			}		
			prefs.setCharPref(uSOverride, overrideString);
			nsIHttpChannel.setRequestHeader('User-Agent', overrideString, false);
		}		
},

observe: function(aSubject, aTopic, aData) {
	try {
		switch (aTopic) {
			case 'app-startup'						:	this.Startup();			break;
			case 'http-on-modify-request'			:	this.userAgent(aSubject);	break;
			case 'xpcom-shutdown'					:	this.Shutdown();		break;
		}
	} catch (err) {}
},
get Shutdown() {
	Services.obs.removeObserver(this, 'http-on-modify-request');
	Services.obs.removeObserver(this, 'xpcom-shutdown');
},
get Startup() {
	Services.obs.addObserver(this, 'xpcom-shutdown', false);
	Services.obs.addObserver(this, 'http-on-modify-request', false);
},
QueryInterface:		XPCOMUtils.generateQI([Ci.nsIObserver]),
_xpcom_categories: [{ category: 'app-startup' }]
};

const NSGetFactory = XPCOMUtils.generateNSGetFactory([nsKmeleonMain]);